      SUBROUTINE stream_add (c,a,b,n)
      REAL*8 c(n),a(n),b(n)
      INTEGER AHEAD
      PARAMETER (AHEAD=128)

      IF (n.LE.AHEAD+1) THEN
         DO j=1,n
            c(j) = a(j)+b(j)
         END DO
      ELSE
         DO j = 1,n-AHEAD,16
!IBM*       CACHE_ZERO (c(j+AHEAD))
            DO i=0,15
               c(j+i) = a(j+i) + b(j+i)
            END DO
         END DO
         DO j=n-AHEAD+1,n
            c(j) = a(j)+b(j)
         END DO
      END IF
      END
